{ lib, config, pkgs, inputs, ... }: let
  pkgsMaster = import inputs.nixpkgs-master { inherit (pkgs) system; config.allowUnfree = true;  };
in {
  
  hardware.opengl = {
    enable = true;
    driSupport = true;
    driSupport32Bit = true;
    extraPackages = with pkgs; [
      vaapiVdpau
      libvdpau-va-gl
      vulkan-validation-layers
    ];
  };

  environment.systemPackages = with pkgs; [
    glxinfo
    clinfo
    virtualglLib
    vulkan-loader
    vulkan-tools

  ];

  services.xserver.videoDrivers = ["nvidia"];

  hardware.nvidia = {
    modesetting.enable = true;
    nvidiaPersistenced = true;

    powerManagement.enable = true;
    powerManagement.finegrained = false;

    open = false;

    nvidiaSettings = true;

    package = config.boot.kernelPackages.nvidiaPackages.beta;
  };

  boot.kernelPackages = pkgsMaster.linuxPackages_latest;
}
